;===============================================================
;
;	Super Laydock
;
;		ステージ初期化処理1
;
;===============================================================
statge_setup:
proc
		call	#0041	; 画面表示停止

		di
		; ステータスエリアPCG
		call	to_init_bank
		call	pcg_status_setup
		call	pcg_message_setup

		; ゲームエリアPCG
		ld		hl,#4c79
		call	statge_setup_open_src
		call	call_hl

		call	to_init_bank
		call	pcg_tweak_page2

		; その他ステージ別データ
		ld		de,#c000
		ld		hl,_tbl
	_lp_load:
		ld		b,(hl)
		bit		7,b
		jr		nz,statge_setup_next
		inc		hl
		ld		a,(hl)
		inc		hl
		push	hl
		ld		h,(hl)
		ld		l,a
		call	statge_setup_open_src
		ld		c,0
		ldir
		pop		hl
		inc		hl
		jr		_lp_load
	_tbl:
		db		#0a
		dw		#4bb9
		db		#08
		dw		#4be9
		db		#07
		dw		#4c19
		db		#07
		dw		#4c49
		db		#ff
endp

statge_setup_open_src:
proc
		ld		a,(#e3ca)  ; ステージ番号
		dec		a
		add		a,a
		add		a,a
		add		a,l
		ld		l,a
		jr		nc,_nc
		inc		h
	_nc:
		ld		a,(hl)
		ld		(#7000),a
		inc		a
		ld		(#7800),a
		inc		hl
		inc		hl
		ld		c,(hl)
		inc		hl
		ld		a,(hl)
		add		a,#80
		ld		h,a
		ld		l,c
		ret
endp


statge_setup_next:
proc
		call	to_init_bank
		call	put_status_area
		call	hkey_setup
		ei

		call	get_stage_bank
		ld		(bank_A000),a
		jr		#4d89
endp

to_init_bank:
proc
		ld		a,4
		ld		(#7000),a
		inc		a
		ld		(#7800),a
		ret
endp

get_stage_bank:
proc
		ld		a,(#e3ca)  
		ld		hl,#4ca9-1	; 0d 0e 0d 0f 10 0d 11 12 13 14 15 16
		add		a,l
		ld		l,a
		ld		a,(hl)
		ret
endp


decompress_to_c000:
		ld	de,#c000
decompress:
		include	"unlzsa1_small.asm"
