;===============================================================
;
;	Super Laydock
;
;		ステージ2背景特殊処理
;
;===============================================================
proc
		call	st02_d277		; 初回のみ呼び出し。呼び出し先でld hlに変わる

		ld		hl,#e3a9
		inc		(hl)
		ld		a,(hl)
		and		15
		dec		a
		jp		z,st02_d237
		sub		8
		jp		z,st02_d344_0
		dec		a
		jp		z,st02_d344_1
		dec		a
		jp		z,st02_d344_2
		ret
endp

;===============================================================
;
;===============================================================
st02_d273:		db	#00,#04,#05,#04
st02_d340:		db	#00,#05,#0e,#0b
st02_d57b:		db	#00,#06,#08,#09,#09,#08,#06,#00

;===============================================================
;	vram最上位アドレス戻す
;===============================================================
st02_end_vram16:
proc
		ld		hl,#8e00
		ld		c,#99
		di
		out		(c),l
		ei
		out		(c),h
		ret
endp
;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値
;===============================================================
st02_anime:
		macro	st02_anime_outs
			out		(c),e
			out		(c),a
			dec		c
			out		(c),d
			inc		c
			add		a,h
		endm
proc
		ld		l,#04
		ld		b,#04
	_lp_page:
		ld		h,#8e
		di
		out		(c),l
		out		(c),h
		ld		h,8
		rept	3
			st02_anime_outs
		endm
		add		a,h
		rept	3
			st02_anime_outs
		endm
		ei
		sub		8*7
		inc		l
		djnz	_lp_page
		ret
endp
;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数
;===============================================================
st02_anime2:
		macro	st02_anime2_outs
			out		(c),e
			out		(c),a
			dec		c
			ld		b,h
		_lp:
			out		(c),d
			djnz	_lp
			inc		c
			add		a,8
		endm

		ld		l,#04	; 最上位アドレス 4→5→6→7
		ld		b,#04	; ループカウンタ 4→3→2→1
st02_anime2p:
proc
		push	bc
		ex		af,af'
		ld		a,#8e
		di
		out		(c),l
		out		(c),a
		ex		af,af'
		rept	3
			st02_anime2_outs
		endm
		add		a,8
		rept	3
			st02_anime2_outs
		endm
		ei
		sub		8*7
		inc		l
		pop		bc
		djnz	st02_anime2p
		ret
endp
;===============================================================
;
;===============================================================
st02_d237:
proc
		ld		hl,#e3a7
		inc		(hl)
		ld		a,(hl)
		and		3
		ld		hl,st02_d273
		add		a,l
		ld		l,a
		ld		d,(hl)
		ld		c,#99

		ld		a,#43
		ld		e,#f1
		jp		st02_anime
endp
;===============================================================
;	電気ビリビリ
;===============================================================
st02_d277:
proc
		;ld		hl,#e3a8		3
		; 初回のみ呼び出す
		ld		a,#21
		ld		(#d200),a

		ld		hl,st02_d340
		ld		bc,#0499
	_lp:
		push	bc
		push	hl
		ld		d,(hl)

		ld		a,b
		add		a,3
		ld		l,a

		ld		a,#45
		ld		e,#48
		ld		h,#38
		ld		b,#01
		call	st02_anime2p
		dec		l

		ld		a,#46
		ld		e,#28
		ld		h,#08
		ld		b,#01
		call	st02_anime2p
		dec		l

		ld		a,#44
		ld		e,#b8
		ld		h,#18
		ld		b,#01
		call	st02_anime2p
		dec		l

		ld		a,#44
		ld		e,#df
		ld		h,#1a
		ld		b,#01
		call	st02_anime2p
		dec		l

		pop		hl
		inc		hl
		pop		bc
		djnz	_lp

		jp		st02_end_vram16
endp
;===============================================================
;
;===============================================================
st02_d344_0:
proc
		ld		hl,#e3aa
		inc		(hl)
		ld		a,(hl)
		and		7
		ld		hl,st02_d57b
		add		a,l
		ld		l,a
		ld		a,(hl)
		or		#20
		ld		d,a
		ld		c,#99


		ld		a,#45
		ld		e,#8e
		call	st02_anime
		ld		a,#45
		ld		e,#96
		call	st02_anime
		ld		a,#47
		ld		e,#49
		call	st02_anime
		ld		a,#47
		ld		e,#51
		call	st02_anime

		jp		st02_end_vram16
endp
st02_d344_1:
proc
		ld		a,(#e3aa)
		and		7
		ld		hl,st02_d57b
		add		a,l
		ld		l,a
		ld		a,(hl)
		or		#20
		and		15
		ld		d,a
		ld		c,#99

		ld		a,#45
		ld		e,#b7
		call	st02_anime
		ld		a,#45
		ld		e,#f7
		call	st02_anime
		ld		a,#46
		ld		e,#08
		call	st02_anime
		ld		a,#46
		ld		e,#cf
		call	st02_anime
		ld		a,#46
		ld		e,#10
		call	st02_anime
		ld		a,#46
		ld		e,#d7
		call	st02_anime

		jp		st02_end_vram16
endp
st02_d344_2:
proc
		ld		a,(#e3aa)
		and		7
		ld		hl,st02_d57b
		add		a,l
		ld		l,a
		ld		a,(hl)
		or		#20
		and		15
		or		#30
		ld		d,a
		ld		c,#99

		ld		a,#46
		ld		e,#45
		ld		h,3
		call	st02_anime2

		ld		a,#46
		ld		e,#80
		ld		h,3
		call	st02_anime2

		ld		a,#46
		ld		e,#5d
		ld		h,3
		call	st02_anime2

		ld		a,#46
		ld		e,#98
		ld		h,3
		call	st02_anime2

		jp		st02_end_vram16
endp
