;===============================================================
;
;	Super Laydock
;
;		ステージ4背景特殊処理
;
;===============================================================
		jp		st04_anime_setup

		ld		hl,#e3a7
		inc		(hl)
		ld		a,(hl)
		ld		b,a
		and		3
		jr		z,st04_d2f4_0
		dec		a
		jr		z,st04_d2f4_1
		dec		a
		jr		z,st04_d2f4_2
		ld		a,b
		and		7
		cp		3
st04_d3c8_artery_ptr:
		jp		z,st04_d3c8_artery_bg
		ret

;===============================================================
;	イルミネーション
;===============================================================
;	色テーブル
st04_d3c0:		db		#00,#06,#08,#06 ,#00

st04_d2f4_0:
		ld		hl,#e3a9
		inc		(hl)
		ld		a,(hl)
		call	st04_d2f4_getval
		ld		a,#47
		ld		e,#4b
		call	st04_anime3			;	a:上位アドレス e:下位アドレス d:出力値1 h:出力値2
		jp		st04_end_vram16
st04_d2f4_1:
		call	st04_d2f4_getval2
		ld		a,#47
		ld		e,#53
		call	st04_anime3			;	a:上位アドレス e:下位アドレス d:出力値1 h:出力値2
		jp		st04_end_vram16
st04_d2f4_2:
		call	st04_d2f4_getval2
		ld		a,#46
		ld		e,#86
		ld		h,#02
		call	st04_anime2			;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数
		jp		st04_end_vram16
st04_d2f4_getval2:
		ld		a,(#e3a9)
st04_d2f4_getval:
		and		3
		ld		hl,st04_d3c0
		add		a,l
		ld		l,a
		ld		d,(hl)
		inc		l
		ld		h,(hl)
		ld		c,#99
		ret

;===============================================================
;	初期処理
;===============================================================
st04_anime_setup:
proc
	; 初回以降は呼び出さない
		ld		a,#21
		ld		(#d200),a

	; 回廊の点滅パターンをセット
		ld		hl,_tbl_corridor
		ld		b,4
		ld		e,#08
	_lp_corridor:
		push	bc
		push	hl
		ld		d,(hl)
		ld		h,#08

		ld		a,3
		add		a,b
		ld		l,a

		ld		a,#42
		call	st04_anime1		; a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数 l:最上位アドレス

		pop		hl
		inc		hl
		pop		bc
		djnz	_lp_corridor

		dec		hl
		dec		hl
		dec		hl
		ld		b,4
		ld		a,e
		add		a,8
		ld		e,a
		cp		#20
		jr		nz,_lp_corridor

	; コア動脈の点滅パターンをセット
		ld		hl,_tbl_artery
		ld		b,4
		ld		e,#c0
	_lp_artery:
		push	bc
		push	hl
		ld		d,(hl)
		ld		h,#20

		ld		a,3
		add		a,b
		ld		l,a

		ld		a,#42
		call	st04_anime1		; a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数 l:最上位アドレス

		dec		l
		ld		a,#46
		call	st04_anime1		; a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数 l:最上位アドレス

		pop		hl
		inc		hl
		pop		bc
		djnz	_lp_artery

	; 終了処理
		jp		st04_end_vram16

	_tbl_corridor:
		db		#90,#80,#60,#80, #90,#80
	_tbl_artery:
		db		#60,#80,#90,#80
endp

;=====================================-
;	コア動脈 BG
;=====================================-
st04_d3c8_artery_bg:
proc
		ld		hl,(#e2e9)
		ld		(_map_pos+1),hl

		ld		hl,#e3aa
		inc		(hl)
		ld		a,(hl)
		and		3
		ld		c,#80
		jr		z,_myaku
		ld		c,#00
	_myaku:

	_cur_list_ptr:
		ld		hl,_pos_list
		ld		a,+(_pos_list_end-_pos_list)/2
		or		a
		jr		z,_delete_proc
		ld		b,a
	_lp:
		ld		a,(hl)
		inc		hl
		push	hl
		ld		h,(hl)
		ld		l,a
		or		a
	_map_pos:
		ld		de,0
		sbc		hl,de
		jr		c,_yet_reach		;未達、終了
		ld		de,24*23
		sbc		hl,de
		jr		nc,_scroll_out		;スクロールアウト
		ld		de,#e0a8+24*23-1
		add		hl,de

		ld		a,(hl)
		and		0x7f
		or		c
		ld		(hl),a
		inc		hl
		ld		a,(hl)
		and		0x7f
		or		c
		ld		(hl),a

		pop		hl
		inc		hl
		djnz	_lp
		ret
	_scroll_out:
		pop		hl
		inc		hl
		ld		(_cur_list_ptr+1),hl
		ld		a,b
		dec		a
		ld		(_cur_list_ptr+4),a
		djnz	_lp
		ret
	_yet_reach:
		pop		hl
		ret

	_delete_proc:
		ld		a,#cd
		ld		hl,st04_d3c8_artery_pcg
		ld		(#d200),a
		ld		(#d201),hl
		ld		a,#c9
		ld		(st04_d3c8_artery_ptr),a
		ret

	_pos_list:
		dw	0xbaa1,0xba59,0xba25,0xb9dd,0xb76d,0xb759,0xb725,0xb711,0xb5a9,0xb561,0xb37d,0xb335,0xb2bd,0xb2a9,0xb275,0xb261
		dw	0xb1e9,0xb1a1,0xadc9,0xad81,0xac49,0xac01,0xab89,0xab41,0xa8cd,0xa885,0xa80d,0xa7c5,0xa65d,0xa649,0xa615,0xa601
		dw	0xa3ed,0xa3d9,0xa3a5,0xa391
	_pos_list_end:
endp
;LC_ALL=C grep -aboU [$'\x58\x5a'] map_04.dat | sort -rn |  awk -F : '{if($1<0x1f80)printf("0x%x,",$1+0xa000)}'

;=====================================-
;	コア動脈 ハッチの絵に戻す
;=====================================-
st04_d3c8_artery_pcg:
proc
		ld		c,#99
	_param:
		ld		de,#0346
		;スプライトにかぶらないように飛ばす
		ld		a,e
		add		a,d
		cp		#5e
		jr		z,_skip_pcg

		; パターン書き換え
		di
		out		(c),d
		ld		a,#8e
		out		(c),a
		ld		a,#c0
		out		(c),a
		out		(c),e
		dec		c
		ld		hl,_pcg_hatch
		ld		b,#20
		otir
		ei
		inc		c

	_skip_pcg:
		ld		a,d
		or		4

		; 色書き換え
		di
		out		(c),a
		ld		a,#8e
		out		(c),a
		ld		a,#c0
		out		(c),a
		out		(c),e
		dec		c
		ld		hl,_col_hatch
		ld		b,#20
		otir
		ei

		; 次回パラメータ
		ld		a,e
		cp		#5e
		jr		z,_next_page
		cp		#7e
		jr		z,_next_page2
		add		a,24
		ld		e,a
		jr		_ret
	_next_page:
		add		a,8
		ld		e,a
		jr		_ret
	_next_page2:
		ld		e,#46
		dec		d
		jp		p,_ret

		; 復旧完了、もう呼び出さない。
		ld		a,#21
		ld		(#d200),a
	_ret:
		ld		(_param+1),de
		jp		st04_end_vram16


	_pcg_hatch:
		db	#9f,#f8,#f8,#ff,#f8,#f9,#fb,#fb
		db	#9c,#cc,#ef,#df,#bf,#bf,#80,#80
		db	#c6,#cc,#f7,#f3,#ed,#dd,#be,#81
		db	#ff,#e0,#e0,#ff,#e0,#9f,#df,#df
	_col_hatch:
		db	#e0,#ef,#fe,#ee,#0e,#e0,#e0,#e0
		db	#e0,#0e,#e0,#e0,#e0,#e0,#0e,#0e
		db	#0e,#e0,#e0,#e0,#e0,#e0,#e0,#0e
		db	#ee,#fe,#ef,#ee,#e0,#e0,#e0,#e0
endp




;===============================================================
;	vram最上位アドレス戻す
;===============================================================
st04_end_vram16:
proc
		ld		hl,#8e00
		ld		c,#99
		di
		out		(c),l
		ei
		out		(c),h
		ret
endp
;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数 l:最上位アドレス
;===============================================================
st04_anime1:
		ld		bc,#0199
		jr		st04_anime2_lp
;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数
;===============================================================
st04_anime2:
		macro	st04_anime2_outs
			out		(c),e
			out		(c),a
			ld		b,h
			dec		c
		_lp:
			out		(c),d
			djnz	_lp
			inc		c
			add		a,8
		endm

		ld		l,#04	; 最上位アドレス 4→5→6→7
		ld		b,#04	; ループカウンタ 4→3→2→1
st04_anime2_lp:
proc
	_lp:
		push	bc
		ex		af,af'
		ld		a,#8e
		di
		out		(c),l
		out		(c),a
		ex		af,af'
		rept	3
			st04_anime2_outs
		endm
		add		a,8
		rept	3
			st04_anime2_outs
		endm
		ei
		sub		8*7
		inc		l
		pop		bc
		djnz	_lp
		ret
endp
;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値1 h:出力値2
;===============================================================
st04_anime3:
		macro	st04_anime3_outs
			out		(c),e
			out		(c),a
			dec		c
			out		(c),h
			nop
			nop
			out		(c),d
			add		a,8
			out		(c),d
			inc		c
	endm
proc
		ld		l,#04
		ld		b,#04
	_lp_page:
		ex		af,af'
		ld		a,#8e
		di
		out		(c),l
		out		(c),a
		ex		af,af'
		rept	3
			st04_anime3_outs
		endm
		add		a,8
		rept	3
			st04_anime3_outs
		endm
		ei
		sub		8*7
		inc		l
		dec		b
		jp		nz,_lp_page
		ret
endp
