;===============================================================
;
;	Super Laydock
;
;		ステージ8背景特殊処理
;
;===============================================================
macro	st08_getdata,	data
		ld		hl,data
		add		a,l
		ld		l,a
		ld		d,(hl)
endm
macro	st08_nextidx,	counter, cycle
		ld		hl,counter
		inc		(hl)
		ld		a,(hl)
		and		cycle
endm
macro	st08_nextdata,	counter, cycle, data
		st08_nextidx	counter, cycle
		st08_getdata	data
endm


;=================================
;	入り口
;=================================
		ld		hl,#e37a
		ld		a,(hl)
		or		a
		jr		nz,_normal
		dec		l
		ld		a,(hl)
		cp		#11
		call	c,st08_resume_core
	_normal:

		st08_nextidx	#e3a7, 15
		add		a,a
		ld		hl,st08_d216
		add		a,l
		ld		l,a
		ld		a,(hl)
		inc		l
		ld		h,(hl)
		ld		l,a
		jp		(hl)

	st08_d216: 
		dw	st08_d237
		dw	st08_d30c
		dw	st08_ret
		dw	st08_ret
		dw	st08_d397
		dw	st08_ret
		dw	st08_ret
		dw	st08_ret
		dw	st08_d296
		dw	st08_d30c
		dw	st08_ret
		dw	st08_ret
		dw	st08_d397
		dw	st08_ret
		dw	st08_ret
		dw	st08_ret

;======================================
;
;======================================
st08_d28e:
		db	#01,#06,#08,#09,#0d,#09,#08,#06
st08_d391:
		db	#01,#2d,#14,#02,#5a,#28
st08_d3ee:
		db	#2c,#c2

;======================================
;
;======================================
st08_d237: 
		st08_nextdata	#e3a8, 7, st08_d28e

		ld		a,#05 | #40
		ld		e,#b6
		call	st08_anime1;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,#05 | #40
		ld		e,#be
		call	st08_anime1;	a:上位アドレス e:下位アドレス d:出力値

		jp		st08_end_vram16

;======================================
;
;======================================
st08_d296:
		ld		a,(#e3a8)
		add		a,4
		and		7
		st08_getdata	st08_d28e

		ld		a,#05 | #40
		ld		e,#f1
		call	st08_anime1;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,#05 | #40
		ld		e,#f9
		call	st08_anime1;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,#05 | #40
		ld		e,#fd
		call	st08_anime1;	a:上位アドレス e:下位アドレス d:出力値

		jp		st08_end_vram16

;======================================
;
;======================================
st08_d30c:
		ld		hl,#e3a9
		inc		(hl)
		ld		a,(hl)
		rrca
		rrca
		rrca
		and		1
		ld		l,a
		add		a,a
		add		a,l
		st08_getdata	st08_d391
		push	hl

		ld		a,#03 | #40
		ld		e,#d4
		call	st08_anime1p;	a:上位アドレス e:下位アドレス d:出力値

		pop		hl
		inc		hl
		ld		d,(hl)
		push	hl

		ld		a,#03 | #40
		ld		e,#d6
		call	st08_anime1p;	a:上位アドレス e:下位アドレス d:出力値

		pop		hl
		inc		hl
		ld		d,(hl)

		ld		a,#03 | #40
		ld		e,#da
		call	st08_anime1p;	a:上位アドレス e:下位アドレス d:出力値

;		jp		st08_end_vram16
;======================================
;	vram最上位アドレス戻す
;======================================
st08_end_vram16:
		ld		hl,#8e00
		ld		c,#99
		di
		out		(c),l
		ei
		out		(c),h
st08_ret:
		ret


;======================================
;
;======================================
st08_d397:
		ld		hl,#e3a9
		rrca
		rrca
		and		1
		st08_getdata	st08_d3ee

		ld		a,#03 | #40
		ld		e,#f4
		call	st08_anime1;	a:上位アドレス e:下位アドレス d:出力値

		ld		a,#03 | #40
		ld		e,#fc
		call	st08_anime1;	a:上位アドレス e:下位アドレス d:出力値

		jp		st08_end_vram16


;=====================================-
;	コアの絵に戻す
;=====================================-
st08_resume_core:
proc
		ld		c,#99
	_param:
		ld		de,#037f
		;スプライトにかぶらないように飛ばす
		ld		a,e
		add		a,d
		cp		#5f
		jr		z,_skip_pcg

		; パターン書き換え
		di
		out		(c),d
		ld		a,#8e
		out		(c),a
		ld		a,#10
		out		(c),a
		out		(c),e
		dec		c
		ld		hl,_pcg_core
		ld		b,#20
		otir
		ei
		inc		c

	_skip_pcg:
		ld		a,d
		or		4

		; 色書き換え
		di
		out		(c),a
		ld		a,#8e
		out		(c),a
		ld		a,#10
		out		(c),a
		out		(c),e
		dec		c
		ld		hl,_col_core
		ld		b,#20
		otir
		ei

		; 次回パラメータ
		ld		a,e
		xor		#20
		ld		e,a
		bit		5,e
		jr		z,_ret
		dec		d
		jp		p,_ret
		; 次ブロックへ
		ld		d,3
		add		a,#e8
		or		#20
		ld		e,a
		cp		#77
		jr		nz,_ret
		; 3ブロック目到達で終了、もう呼び出さない。
		ld		hl,#0c18
		ld		(#d200),hl
	_ret:
		ld		(_param+1),de
		jp		st08_end_vram16

	_pcg_core:
		db	#f7,#cb,#e5,#f2,#f9,#bf,#af,#8b,#ef,#d3,#a7,#4f,#9f,#fd,#f5,#d1,#7f,#ff,#f3,#e3,#e7,#cf,#cf,#ff,#fe,#ef,#ff,#fb,#fd,#fb,#f5,#fb
	_col_core:
		db	#0e,#0e,#0e,#0e,#0e,#0e,#0e,#0e,#0e,#0e,#0e,#0e,#0e,#0e,#0e,#0e,#09,#00,#0f,#0f,#0f,#06,#08,#00,#08,#0e,#00,#0e,#0e,#0e,#0e,#0e
endp



;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値
;===============================================================
macro	st08_anime1_outs
		out		(c),e
		out		(c),a
		dec		c
		add		a,8
		out		(c),d
		inc		c
endm
st08_anime1p:
		ld		hl,#8e00
		jp		st08_anime1_cmn
st08_anime1:
		ld		hl,#8e04
st08_anime1_cmn:
proc
		ld		bc,#0499
	_lp_page:
		di
		out		(c),l
		out		(c),h
		rept	3
			st08_anime1_outs
		endm
		add		a,8
		rept	3
			st08_anime1_outs
		endm
		ei
		sub		8*7
		inc		l
		djnz	_lp_page
		ret
endp
