;===============================================================
;
;	Super Laydock
;
;		ステージ10背景特殊処理
;
;===============================================================
macro	st10_getdata,	counter, cycle, data
		ld		a,(counter)
		and		cycle
		ld		hl,data
		add		a,l
		ld		l,a
		ld		d,(hl)
endm
macro	st10_nextidx,	counter, cycle
		ld		hl,counter
		inc		(hl)
		ld		a,(hl)
		and		cycle
endm
macro	st10_nextdata,	counter, cycle, data
		st10_nextidx	counter, cycle
		ld		hl,data
		add		a,l
		ld		l,a
		ld		d,(hl)
endm


;=================================
;	入り口
;=================================
		st10_nextidx	#e3a7, 7
		add		a,a
		ld		hl,st10_d216
		add		a,l
		ld		l,a
		ld		a,(hl)
		inc		l
		ld		h,(hl)
		ld		l,a
		jp		(hl)

st10_d216:
		dw		st10_d227
		dw		st10_ret
		dw		st10_d265
		dw		st10_d265_2
		dw		st10_d38a
		dw		st10_d38a_2
		dw		st10_ret
		dw		st10_ret

;======================================
;
;======================================
st10_d25d:
		db	#40,#46,#48,#49,#49,#48,#46,#40

;======================================
;
;======================================
st10_d227: 
		st10_nextidx	#e3a8, 7, st10_d25d
		ld		hl,st10_d25d
		add		a,l
		ld		l,a
		ld		a,(hl)
		or		#40
		ld		d,a

		ld		a,#03 | #40
		ld		e,#9b
		call	st10_anime1

		jp		st10_end_vram16

;======================================
;
;======================================
st10_d265:
		st10_nextdata	#e3a9, 7, st10_d25d

		ld		a,#02 | #40
		ld		e,#c1
		ld		h,#02
		call	st10_anime2

		ld		a,#02 | #40
		ld		e,#c5
		ld		h,#02
		call	st10_anime2

		ld		a,#02 | #40
		ld		e,#cb
		ld		h,#02
		call	st10_anime2

		;	vram最上位アドレス戻す
st10_end_vram16:
		ld		hl,#8e00
		ld		c,#99
		di
		out		(c),l
		ei
		out		(c),h
st10_ret:
		ret

st10_d265_2:
		st10_getdata	#e3a9, 7, st10_d25d

		ld		a,#02 | #40
		ld		e,#d3
		ld		h,#02
		call	st10_anime2

		ld		a,#02 | #40
		ld		e,#d9
		ld		h,#02
		call	st10_anime2

		ld		a,#02 | #40
		ld		e,#dd
		ld		h,#02
		call	st10_anime2

		jp		st10_end_vram16


;======================================
;
;======================================
st10_d38a:
		st10_getdata	#e3a9, 7, st10_d25d

		ld		a,#02 | #40
		ld		e,#ee
		ld		h,#02
		call	st10_anime2

		ld		a,#02 | #40
		ld		e,#f6
		ld		h,#02
		call	st10_anime2

		jp		st10_end_vram16

st10_d38a_2:
		st10_getdata	#e3a9, 7, st10_d25d

		ld		a,#03 | #40
		ld		e,#2c
		ld		h,#02
		call	st10_anime2

		ld		a,#03 | #40
		ld		e,#34
		ld		h,#02
		call	st10_anime2

		jp		st10_end_vram16


;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数
;===============================================================
		macro	st10_anime2_outs
			out		(c),e
			out		(c),a
			ld		b,h
			dec		c
		_lp:
			out		(c),d
			djnz	_lp
			inc		c
			add		a,8
		endm
st10_anime1:
		ld		h,1
st10_anime2:
		ld		l,#04		; 最上位アドレス 4→5→6→7
st10_anime2_lp:
		ld		bc,#0499	; ループカウンタ 4→3→2→1
proc
	_lp:
		push	bc
		ex		af,af'
		ld		a,#8e
		di
		out		(c),l
		out		(c),a
		ex		af,af'
		rept	3
			st10_anime2_outs
		endm
		add		a,8
		rept	3
			st10_anime2_outs
		endm
		ei
		sub		8*7
		inc		l
		pop		bc
		djnz	_lp
		ret
endp
