;===============================================================
;
;	Super Laydock
;
;		ステージ12背景特殊処理
;
;===============================================================
macro	st12_getptr,	counter, data
		ld		a,(counter)
		ld		hl,data
		add		a,l
		ld		l,a
endm
macro	st12_nextidx,	counter, cycle
		ld		hl,counter
		ld		a,(hl)
		inc		a
		and		cycle
		ld		(hl),a
endm
macro	st12_nextdata,	counter, cycle, data
		st12_nextidx	counter, cycle
		ld		hl,data
		add		a,l
		ld		l,a
		ld		d,(hl)
endm
macro	st12_bossret		; 最終ボス(15面)は何もしない
		ld		a,(#e3ca)
		cp		15
		ret		z
endm


;=================================
;	入り口
;=================================
proc
		st12_nextidx	#e3a7, 0x1f
		bit		0,a
		ret		nz
		ld		hl,st12_d216
		add		a,l
		ld		l,a
		ld		a,(hl)
		inc		l
		ld		h,(hl)
		ld		l,a
		jp		(hl)
endp

st12_d216:
		dw	st12_d257
		dw	st12_d292
		dw	st12_d2c6
		dw	st12_d3d6_b0
		dw	st12_d498
		dw	st12_d3d6_b1
		dw	st12_d498
		dw	st12_d3d6_b2
		dw	st12_d2fa
		dw	st12_d32e
		dw	st12_d362
		dw	st12_ret
		dw	st12_d498
		dw	st12_ret
		dw	st12_d498
		dw	st12_ret

;=================================
st12_d501:
		db	#00,#06,#08,#09,#09,#08,#06,#00

;=================================
st12_d396:
		db	#00,#01,#0e,#1f,#1e,#15,#6a,#f1,#00,#c0,#a0,#5c,#0d,#5c,#e5,#c2
		db	#f2,#ad,#4e,#0a,#75,#28,#1a,#01,#a0,#42,#09,#12,#25,#0a,#a0,#40
		db	#00,#00,#03,#06,#18,#32,#27,#16,#00,#00,#00,#60,#e0,#d0,#20,#0c
		db	#02,#28,#6c,#44,#31,#02,#01,#00,#1c,#4a,#e4,#40,#04,#a8,#40,#00

;=================================
st12_d458:
		db	#82,#c3,#67,#3e,#14,#f8,#50,#28,#03,#7e,#d4,#80,#03,#0e,#7c,#d0
		db	#63,#ce,#9a,#28,#63,#46,#e4,#86,#8c,#87,#02,#00,#f0,#bc,#16,#03
		db	#e3,#79,#1b,#4e,#fe,#a4,#34,#62,#03,#86,#9c,#f4,#d1,#07,#0e,#78
		db	#c7,#9d,#14,#30,#21,#33,#63,#c6,#f0,#5b,#0e,#f0,#bc,#16,#06,#03

;=================================	; 最終ボス(15面)切り替え処理
st12_to_st15:
proc
	_num		equ	2
	_param:
		ld		a,#60-_num
		ld		hl,#97f0-16*_num
		add		a,_num
		cp		#80
		jr		z,_complete
		ld		bc,16*_num
		add		hl,bc
		ld		(_param+1),a
		ld		(_param+3),hl

		ex		af,af'
		ld		a,#0c
		di
		ld		(#7000),a
		ld		de,st12_d396
		ldir
		ld		a,#02
		ld		(#7000),a
		ei

		ex		af,af'
		ld		b,2
		ld		hl,st12_d396
		jp		#40A8			; PCG n文字書き換え

	_complete:
		ld		a,#c9
		ld		(st12_d257),a	; もう呼び出さない
		ret
endp
;=================================
st12_d257:
		ld		a,(#e3ca)
		cp		15
		jr		z,st12_to_st15		; 最終ボス(15面)切り替え処理へ

		ld		hl,#e3a8
		ld		a,(hl)
		add		a,#20
		and		#20
		ld		(hl),a
		ld		hl,st12_d396
		add		a,l
		ld		l,a

		ld		de,#4300
		jp		st12_write
;=================================
st12_d292:
		st12_bossret		; 最終ボス(15面)は何もしない
		st12_getptr	#e3a8, st12_d396
		ld		de,#4b00
		jp		st12_write
;=================================
st12_d2c6:
		st12_bossret		; 最終ボス(15面)は何もしない
		st12_getptr	#e3a8, st12_d396
		ld		de,#5300
		jp		st12_write
;=================================
st12_d2fa:
		st12_bossret		; 最終ボス(15面)は何もしない
		st12_getptr	#e3a8, st12_d396
		ld		de,#4320
		jp		st12_write
;=================================
st12_d32e:
		st12_bossret		; 最終ボス(15面)は何もしない
		st12_getptr	#e3a8, st12_d396
		ld		de,#4b20
		jp		st12_write
;=================================
st12_d362:
		st12_bossret		; 最終ボス(15面)は何もしない
		st12_getptr	#e3a8, st12_d396
		ld		de,#5320
		jp		st12_write
;=================================
st12_d3d6_b0
		st12_getptr	#e3a8, st12_d458
		ld		de,#42a0
		jp		st12_write
;=================================
st12_d3d6_b1
		st12_getptr	#e3a8, st12_d458
		ld		de,#4aa0
		jp		st12_write
;=================================
st12_d3d6_b2
		st12_getptr	#e3a8, st12_d458
		ld		de,#52a0
		jp		st12_write
;=================================
st12_d498:
		; 最終ボス(15面)までは何もしない
		ld		a,(#e3ca)
		cp		15
		ret		nz

		st12_nextdata	#e3a9, 7, st12_d501

		ld		a,#03 | #40
		ld		e,#41
		ld		h,#04
		call	st12_anime2

		ld		a,#03 | #40
		ld		e,#58
		ld		h,#10
		call	st12_anime2

		ld		a,#03 | #40
		ld		e,#70
		ld		h,#08
		call	st12_anime2

		ld		a,#03 | #40
		ld		e,#90
		ld		h,#08
		call	st12_anime2

		ld		a,#03 | #40
		ld		e,#a8
		ld		h,#08
		call	st12_anime2

		jp		st12_end_vram16






;===============================================================
;	PCG2x2書き込み	hl:データ de:or40済みオフセットアドレス
;===============================================================
st12_write:
proc
		ld		bc,#0899
	_lp:
		ld		a,b
		rrca
		and		3
		di
		out		(c),a
		ld		a,#8e
		out		(c),a

		out		(c),e
		out		(c),d
		ld		a,b
		ld		b,#10
		dec		c
		otir
		inc		c
		ld		b,a

		ld		a,e
		add		a,#40
		ld		e,a

		out		(c),e
		out		(c),d
		ld		a,b
		ld		b,#10
		dec		c
		otir
		ei
		inc		c
		ld		b,a

		ld		a,d
		xor		#20
		ld		d,a

		ld		a,e
		sub		#40
		ld		e,a

		ld		a,l
		sub		#20
		ld		l,a

		djnz	_lp
endp
st12_end_vram16:
		ld		hl,#8e00
		di
		out		(c),l
		ei
		out		(c),h
st12_ret:
		ret


;===============================================================
;	a:上位アドレス e:下位アドレス d:出力値 h:繰り返し回数
;===============================================================
		macro	st12_anime2_outs
			out		(c),e
			out		(c),a
			ld		b,h
			dec		c
		_lp:
			out		(c),d
			djnz	_lp
			inc		c
			add		a,8
		endm
st12_anime2:
		ld		l,#04		; 最上位アドレス 4→5→6→7
st12_anime2_lp:
		ld		bc,#0499	; ループカウンタ 4→3→2→1
proc
	_lp:
		push	bc
		ex		af,af'
		ld		a,#8e
		di
		out		(c),l
		out		(c),a
		ex		af,af'
		rept	3
			st12_anime2_outs
		endm
		add		a,8
		rept	3
			st12_anime2_outs
		endm
		ei
		sub		8*7
		inc		l
		pop		bc
		djnz	_lp
		ret
endp

