;===============================================================
;
;	Super Laydock
;
;		フォント書き込み
;
;===============================================================
;===============================================================
;	ステータス用文字列書き込み
;		hl[de:書き込み先アドレス,b,...]
;===============================================================
write_status_str:
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		inc		hl
		ld		b,(hl)
		inc		hl
write_status_str_loop:
		ld		a,(hl)
		inc		hl
		push	bc
		push	hl
		push	de
		call	write_status_font
		pop		de
		ld		hl,#40
		add		hl,de
		ex		de,hl
		pop		hl
		pop		bc
		djnz	write_status_str_loop
write_end:
		di
		ld		hl,#8e00
		out		(c),l
		out		(c),h
		ei
		ret

;===============================================================
;	スコア文字列書き込み
;		hl:スコア	de:書き込み先アドレス(ページ7ブロック0から、 0x40済み)
;===============================================================
write_score:
proc
		ld		a,(hl)
		rrca
		and		#78
		push	hl
		push	de
		call	write_status_font2
		pop		de
		ld		hl,#40
		add		hl,de
		ex		de,hl
		pop		hl
endp
write_score2:
proc
		ld		a,(hl)
		and		#0f
		push	hl
		push	de
		call	write_status_font
		pop		de
		ld		hl,#40
		add		hl,de
		ex		de,hl
		pop		hl
		inc		l
		ld		a,l
		cp		#8b
		jr		z,write_end
		cp		#8e
		jr		z,write_end
		jr		write_score
endp

;===============================================================
;	ステータス用フォント書き込み
;		a:フォント番号	de:書き込み先アドレス(ページ7ブロック0から、 0x40済み)
;===============================================================
write_status_font2:
		ld		h,pcg_font>>8
		ld		l,a
		jp		write_status_font_core
write_status_font:
proc
		add		a,a
		add		a,a
		add		a,a
		ld		l,a
		ld		a,pcg_font>>8
		adc		a,0
		ld		h,a
	endp
write_status_font_core:
	proc
		ld		a,d
		ld		bc,#499
		di
	_lpB:
		ld		d,b
		dec		b
		out		(c),b
		ld		b,#8e
		out		(c),b
	_lp:
		inc		e
		jr		nz,_nz
		inc		a
	_nz:
		out		(c),e
		out		(c),a
		ld		b,8
		dec		c
		push	hl
		otir
		pop		hl
		inc		c

		xor		#20
		bit		5,a
		jr		z,_lp
		ld		b,d
		djnz	_lpB

		ei
		ret
endp


;===============================================================
;	メッセージ用フォント連続書き込み
;		hl[de:書き込み先アドレス(ページ7ブロック0から、 0x40済み),a:フォント番号]
;===============================================================
write_message_fonts:
proc
	_lp:
		ld		a,(hl)
		or		a
		ret		z
		ld		e,a
		inc		hl
		ld		d,(hl)
		inc		hl
		ld		a,(hl)
		inc		hl
		push	hl
		call	write_message_font
		pop		hl
		jr		_lp
		ret
endp
;===============================================================
;	メッセージ用フォント書き込み
;		a:フォント番号	de:書き込み先アドレス(ページ7ブロック0から、 0x40済み)
;===============================================================
write_message_font:
proc
		add		a,a
		add		a,a
		add		a,a
		ld		l,a
		ld		a,pcg_font>>8
		adc		a,0
		ld		h,a

		ld		a,d
		ld		bc,#0499
		di
	_lp_page_h:
		ld		d,b
		dec		b
		out		(c),b
		ld		b,#8e
		out		(c),b
	_lp_page_l:
		out		(c),e
		out		(c),a
		ld		b,8
		dec		c
		push	hl
		otir
		pop		hl
		inc		c

		xor		#20
		bit		5,a
		jr		z,_lp_page_l

		ld		b,d
		djnz	_lp_page_h
		ei
		ret
endp
;===============================================================
;	メッセージ表示
;===============================================================
put_message:
proc
		di
		ld		(msg_area),a
		ld		(msg_area+1),de
		ld		de,msg_area+3
		ld		c,a
		ld		b,0
		ldir
		ei
		ret
endp
put_message_stage:
proc
		ld		hl,cur_message
		ld		a,(#e3ca)  ; ステージNo
		cp		(hl)
		jr		z,_skip_write
		ld		(hl),a

		ld		hl,_tbl1
		call	write_message_fonts

		ld		a,(#e3ca)  ; ステージNo
		sub		10
		push	af
		jr		nc,_wrt_01
		add		a,10
	_wrt_01:
		ld		de,#6800+#0f*8
		call	write_message_font
		pop		af
		ld		a,#24
		jr		c,_wrt_10
		ld		a,1
	_wrt_10:
		ld		de,#6800+#0e*8
		call	write_message_font

	_skip_write:

		ld		hl,_tbl2
		ld		de,#7989	; y:12*32+x:9
		ld		a,7
		jp		put_message
	_tbl1:
		dw	#6820
		db	#1c
		dw	#6828
		db	#1d
		dw	#6830
		db	#0a
		dw	#6838
		db	#10
		dw	#69e0
		db	#0e
		db	0
	_tbl2:
		db	4,5,6,7,#3c,#0e,#0f
endp
put_message_ready:
proc
		ld		hl,cur_message
		ld		a,#10
		cp		(hl)
		ld		(hl),a
		ld		hl,_tbl1
		call	nz,write_message_fonts

		ld		hl,_tbl2
		ld		de,#798a	; y:12*32+x:10
		ld		a,5
		jp		put_message
	_tbl1:
		dw	#6820
		db	#1b
		dw	#6828
		db	#0e
		dw	#6830
		db	#0a
		dw	#6838
		db	#0d
		dw	#69e0
		db	#22
		db	0
	_tbl2:
		db	4,5,6,7,#3c
endp
put_message_gameover:
proc
		ld		hl,cur_message
		ld		a,#11
		cp		(hl)
		ld		(hl),a
		ld		hl,_tbl1
		call	nz,write_message_fonts

		ld		hl,_tbl2
		ld		de,#7988	; y:12*32+x:8
		ld		a,9
		jp		put_message
	_tbl1:
		dw	#6820
		db	#10
		dw	#6828
		db	#0a
		dw	#6830
		db	#16
		dw	#6838
		db	#0e
		dw	#69e0
		db	#18
		dw	#69e8
		db	#1f
		dw	#69f0
		db	#0e
		dw	#69f8
		db	#1b
		db	0
	_tbl2:
		db	4,5,6,7,#0d,#3c,#3d,#3e,#3f
endp


;===============================================================
;	シールド表示
;===============================================================
update_gauge_shield_1p:
proc
		ld		a,(#e2f3)	; シールド1p
		ld		de,#7098
		ld		b,5
		call	update_shield_gauge
		ld		de,#68b8
		ld		b,5
		jp		update_shield_gauge2
endp
update_gauge_shield_2p:
proc
		ld		a,(#e2fb)	; シールド2p
		ld		de,#7098+#80
		ld		b,5
		call	update_shield_gauge
		ld		de,#68b8+#80
		ld		b,5
		jp		update_shield_gauge2
endp
update_gauge_docking:
proc
		ld		a,(#e37c)	; ドッキングエネルギー
		ld		de,#7098+#100
		ld		b,5
		call	update_shield_gauge
		ld		de,#68b8+#100
		ld		b,5
		jp		update_shield_gauge2
endp
update_shield_gauge:
proc
		or		a
		jr		z,_empty
		sub		#02
		jr		c,_half
		ld		hl,pcg_font+8*#26	; 2マス
		jr		update_shield_gauge2
	_half:
		inc		a
		ld		hl,pcg_font+8*#25	; 1マス
		jr		update_shield_gauge2
	_empty:
		ld		hl,pcg_font+8*#24	; 空白
endp
update_shield_gauge2:
proc
		ld		c,a
		push	bc
		push	de
		call	write_status_font_core
		pop		de
		ld		a,e
		sub		8
		ld		e,a
		jr		nc,_nc
		dec		d
	_nc:
		pop		bc
		ld		a,c
		djnz	update_shield_gauge
		ret
endp

		
;===============================================================
;	オプションウェポン名表示
;===============================================================
init_option_disp:
proc
		ld		hl,_tbl_airbone
		ld		a,(#e489)	; 種別
		or		a
		jr		z,_wrt
		dec		a
		jr		z,_end_type
		ld		hl,_tbl_surface
	_end_type:
		ld		a,(#e48a)	; 番号
		add		a,a
		ld		b,a
		add		a,a
		add		a,b
		ld		b,a
		add		a,l
		ld		l,a
		jr		nc,_wrt
		inc		h
	_wrt:
		ld		de,#6848
		ld		b,6
		jp		write_status_str_loop

	_tbl_airbone:
		db	#24, #24, #24, #24, #24, #24	;
		db	#24, #1D, #18, #1B, #0A, #24	; TORA
		db	#0A, #15, #19, #11, #0A, #24	;ALPHA
		db	#1C, #19, #0E, #0C, #0A, #15	;SPECAL
		db	#16, #0E, #1B, #1B, #22, #24	;MERRY 
		db	#14, #12, #15, #15, #0E, #1B	;KILLER
	_tbl_surface:
		db	#24, #24, #24, #24, #24, #24	;
		db	#0B, #1E, #15, #0D, #18, #10	;BULDOG
		db	#0D, #18, #1E, #0B, #15, #0E	;DOUBLE
		db	#0C, #18, #17, #0D, #18, #1B	;CONDOR
		db	#24, #1C, #15, #18, #20, #24	; SLOW 
		db	#24, #0F, #12, #1B, #0E, #24	; FIRE 
endp


;===============================================================
;	clear vram
;===============================================================
clear_vram_all:
proc
		ld		hl,#8e07
		ld		bc,#99
	_lp_page:
		ld		de,#4000
		di
		out		(c),l
		out		(c),h
		out		(c),e
		out		(c),d
		dec		c
	_lp:
		out		(c),e
		djnz	_lp
		dec		d
		jr		nz,_lp
		ei
		inc		c
		dec		l
		jp		p,_lp_page
		ret
endp
