;===============================================================
;
;	Super Laydock
;
;		ステータス用PCGを展開
;
;===============================================================

;===============================================================
;
;	ステータス用PCGを展開
;
;===============================================================
pcg_status_setup:
proc
		ld		hl,pcg_status
		call	decompress_to_c000

		ld		hl,#c000
		ld		de,#0040
		call	_wrt_pgt_ct
		ld		hl,#c000+9*8*4*8
		ld		de,#0440
	_wrt_pgt_ct:

		; 8ページ分
		ld		bc,#0899
	_lpPage:
		push	bc
		push	hl

		; 4ブロック分
		ld		b,4
	_lpBlock:
		push	bc
		out		(c),d
		ld		a,#8e
		out		(c),a
		xor		a
		out		(c),a
		out		(c),e
		dec		c

		; 縦8列分
		ld		b,8
	_lpHorz:
		push	bc

		; 縦一列8文字分
		ld		b,8*8
		otir

		; 最後の1文字を飛ばす
		ld		a,l
		add		a,8
		ld		l,a
		jr		nc,_nc
		inc		h
	_nc:

		; 次の列へ
		pop		bc
		djnz	_lpHorz

		; アドレス移動
		ld		a,e
		add		a,8
		ld		e,a
		cp		#80
		jr		nz,_nz
		inc		d
		ld		e,#40
	_nz:

		; 次のブロックへ
		pop		bc
		djnz	_lpBlock

		; 次のページへ
		pop		hl
		inc		hl
		pop		bc
		djnz	_lpPage
		ret
endp
;===============================================================
;
;	メッセージ用PCGの準備(色)
;
;===============================================================
pcg_message_setup:
proc
		ld		hl,_tbl_alpha
		ld		b,4
		ld		de,#6820
		call	_writes
		ld		b,4
		ld		de,#69e0
		call	_writes

		ld		hl,_tbl_num
		ld		b,2
		ld		de,#6870
	_writes:
		push	bc
		push	de
		call	_write
		pop		de
		ld		a,e
		add		a,8
		ld		e,a
		pop		bc
		djnz	_writes

		ld		de,#8e00	; 戻しとく
		;di
		out		(c),e
		out		(c),d
		;ei
		ret

	_write:
		ld		a,d
		ld		bc,#0499
		;di
	_lp_page_h:
		ld		d,b
		dec		b
		set		2,b
		out		(c),b
		ld		b,#8e
		out		(c),b
	_lp_page_l:
		out		(c),e
		out		(c),a
		ld		b,8
		dec		c
		push	hl
		otir
		pop		hl
		inc		c

		xor		#20
		bit		5,a
		jr		z,_lp_page_l

		ld		b,d
		djnz	_lp_page_h
		;ei
		ret
	_tbl_alpha:
		db	#f1,#f1,#f1,#f1,#51,#e1,#e1,#11
	_tbl_num:
		db	#c1,#21,#31,#31,#f1,#f1,#f1,#11
endp
;===============================================================
;
;	ステータスエリアの枠を描画
;
;===============================================================
put_status_area:
proc
		ld		bc,#0499
		ld		hl,#8e00
		out		(c),l
		out		(c),h
		ld		hl,#7818
		ld		de,#20
	_lpB:
		push	bc
		xor		a
        ld		b,8
	_lpY:
		push	bc
		out		(c),l
		out		(c),h
		dec		c
		ld		b,8
	_lpX:
		out		(c),a
		add		a,8
		djnz	_lpX
		sub		#3f
		add		hl,de
		pop		bc
		djnz	_lpY
		pop		bc
		djnz	_lpB

		; 同じ部品を縦に並べる(メッセージ用にフォントの空きを作る)
		ld		hl,_vert_dat
	_put_verts:
		ld		b,(hl)
		ld		a,b
		or		a
		ret		z
		inc		hl
		ld		a,(hl)
		inc		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		inc		hl
		push	hl
		ex		de,hl
		ld		de,#20
	_put_vert_lp:
		out		(c),l
		out		(c),h
		dec		c
		out		(c),a
		add		hl,de
		inc		c
		djnz	_put_vert_lp
		pop		hl
		jr		_put_verts

	_vert_dat:
		db		9,3
		dw		#7800+32*12+24
		db		7,3
		dw		#7800+32*10+31
		db		1,57
		dw		#7800+32* 8+31
		db		1,58
		dw		#7800+32* 9+31

		db		4,12
		dw		#7800+32*13+25
		db		4,12
		dw		#7800+32*13+27
		db		3,8
		dw		#7800+32*16+25
		db		3,8
		dw		#7800+32*16+27
		db		0				; ゼロ終端
endp
;===============================================================
;
;	ページ2でPGTとPNTが被る問題回避
;
;===============================================================
pcg_tweak_page2:
proc
		ld		hl,_tbl
		ld		c,#99
		call	_lpA
	_lpA:
		outi
		outi
		ld		b,2*(1+3)
	_lp:
		outi
		outi
		dec		c
		outi
		inc		c
		djnz	_lp
		ret
	_tbl:
		db		#04,#8e
		db		#07,#7f,#ef
		db		#47,#7f,#fe
		db		#00,#8e
		db		#07,#7f,#fc
		db		#47,#7f,#cb
endp
