;===============================================================
;
;	Super Laydock
;
;		スムーススクロール対応
;
;===============================================================
include	"slss-q.asm"
macro	org_add ,val
	_cur_adr:
		org	_cur_adr+val
endm
macro	org_sub ,val
	_cur_adr:
		org	_cur_adr-val
endm

macro	filler ,adr
	filler_##adr:
		if	adr < filler_##adr
			.ERROR	adr < filler_##adr
		endif
		ds	adr-filler_##adr
endm

macro	align,x
	_align:
		if 0 <(_align & (x - 1))
			ds	x -(_align & (x - 1))
		endif
endm


;===============================================================
;	def
;===============================================================
romadr	0
ifndef SuperLaydock_bv
		incbin	"../../SuperLaydock.rom"
else
		incbin	"../../SuperLaydock-bv.rom"
endif


hkey_org		equ	#ea00
wk_top			equ	#f380-#30
next_bg			equ	wk_top
msg_area		equ next_bg+24
bank_A000		equ	msg_area+12
cur_page		equ bank_A000+1
disp_flag		equ cur_page+1
is_scroll		equ disp_flag+1
cur_weapon		equ is_scroll+1
cur_message		equ cur_weapon+1
cur_shild1		equ cur_message+1
spr_bg_ofs		equ cur_shild1+1


; BGのスクロールに合わせて移動する物体の位置修正
macro	adjust_y_to_bg
		ld		a,(is_scroll)
		add		a,(hl)
		ld		(hl),a
		jp		_end
		ds		2
	_end:
endm
macro	adjust_y_to_bg2, y_adr
		ld		a,(is_scroll)
		ld		hl,y_adr
		add		a,(hl)
		ld		(hl),a
endm

;===============================================================
;	BANK 0
;===============================================================
romadr	#00ab
org		#40ab
		call	write_a_pcg;   #40b9      ; PCG1文字書き換え a:番号 hl:データ

romadr	#00b9
org		#40b9
		jp		write_a_pcg
filler	#40f0


romadr	#011f
org		#411f
		include	"slss-0011f_update_weapon_disp.asm"
filler	#4138


romadr	#01B2
org		#41B2
		ret					; SAT転送
call_hl:
		jp		(hl)
call_ix:
		jp		(ix)
call_bank_pcg_font:
		ld		a,bank_pcg_font
call_bank_A000:
		ld		(#7800),a
		call	call_ix
		ld		a,(bank_A000)
		ld		(#7800),a
		ret
filler	#41e0


romadr	#0a4f
org		#4a4f
		call	update_is_scroll	;call   #5213			; BGをPNTに転送	vPNT:#e0a8


romadr	#0aac
		ld		sp,wk_top		; ワークエリア戴き


;--------------------------------
; ステージ初期化
;--------------------------------
romadr	#0c79
org		#4c79
	macro pcg_bg_adr, adr
		db	+(adr/0x2000),0
		dw	adr & 0x1fff
	endm
		pcg_bg_adr	pcg_bg0
		pcg_bg_adr	pcg_bg1
		pcg_bg_adr	pcg_bg0
		pcg_bg_adr	pcg_bg2
		pcg_bg_adr	pcg_bg3
		pcg_bg_adr	pcg_bg0
		pcg_bg_adr	pcg_bg4
		pcg_bg_adr	pcg_bg5
		pcg_bg_adr	pcg_bg6
		pcg_bg_adr	pcg_bg7
		pcg_bg_adr	pcg_bg8
		pcg_bg_adr	pcg_bg9
filler	#4CA9


; ステージ初期化1
romadr	#0cb5
org		#4cb5
		include	"slss-00cb5_statge_setup.asm"
filler	#4D89

; ステージ初期化2
romadr	#0dd0
org		#4dd0
		include	"slss-00dd0_statge_setup2.asm"
call_put_message_ready:
		ld		ix,put_message_ready
		jp		call_bank_pcg_font
call_put_message_gameover:
		ld		ix,put_message_gameover
		jp		call_bank_pcg_font
filler	#4E67

; ステージNo表示
romadr	#0eca
org		#4eca
		call	call_put_message_stage
filler	#4edc

; SPGアドレス変更のため
romadr	#00f1
org		#40f1
		ld		h,#0b      ; de=(0b00+a)*8

; PNTアドレス変更のため
romadr	#011b
org		#411b
		ld		d,#78

; READY表示
romadr	#0f67
org		#4f67
		call	call_put_message_ready
filler	#4f70

; ステージ初期化3
romadr	#0f77
org		#4f77
		include	"slss-00f77_statge_setup3.asm"
filler	#4fc4

;--------------------------------
; ステージ初期化 end
;--------------------------------

; GAME OVER表示
romadr	#0ffd
org		#4ffd
		call	call_put_message_gameover


; スクロール処理の最後を修正
romadr	#110B
org		#510B
		jp     copy_next_bg_on_scroll

; PNTアドレス変更のため
romadr	#121a
org		#521a
		ld		hl,#7800

; ステージ13,14表示
romadr	#1248
org		#5248
call_put_message_stage:
		ld		ix,put_message_stage
		jp		call_bank_pcg_font
filler	#526C

; ステージBG初期表示他、内
romadr	#12d5
org		#52d5
		call	copy_next_bg_on_init

; ロゴがキラリ
romadr	#1448
org		#5448
		include	"slss-01448_logo.asm"
filler	#54cc			;#54e4-24
; スプライト→BG座標変換修正
bgchk_54FE:
		ld		a,(spr_bg_ofs)
		add		a,l
		ld		l,a
		jp		#54fe
bgchk_5528:
		ld		a,(spr_bg_ofs)
		add		a,l
		ld		l,a
		jp		#5528
bgchk_554F:
		ld		a,(spr_bg_ofs)
		add		a,l
		ld		l,a
		jp		#554f
; スプライト→BG座標変換修正、呼び出し元変更
ifndef SuperLaydock_bv
	irp adr,#46d8,#4782,#4cd5,#4dd8,#4f32,#517f,#529e,#533d,#539f,#553d,#564a
			romadr	adr
				call	bgchk_54FE
	endm
else
	irp adr,#46d8,#4782,#4cd5,#4dd8,#4fa3,#517f,#529e,#533d,#539f,#553d,#564a
			romadr	adr
				call	bgchk_54FE
	endm
endif
irp adr,#39dc,#3a9a,#3b47,#3bf4,#3d4c,#3dc0,#5c34
		romadr	adr
			call	bgchk_5528
endm
irp adr,#45ef,#54d4
		romadr	adr
			call	bgchk_554F
endm
;for i in $'\xcd\xfe\x54' $'\xcd\x28\x55' $'\xcd\x4f\x55' ; do
;  grep -aboU "$i"  ../SuperLaydock.rom | awk -F : '{printf("#%x,",$1)}'
;  echo
;  grep -aboU "$i"  ../SuperLaydock-sv.rom | awk -F : '{printf("#%x,",$1)}'
;  echo
;done



;===============================================================
;	BANK 1
;===============================================================
; 隠しキャラスクロール
romadr	#2e57
org		#6e57
		adjust_y_to_bg	; ネッシースクロール
filler	#6e61

romadr	#2e8e
org		#6e8e
		adjust_y_to_bg	; ネッシースクロール
filler	#6e98

romadr	#2f3f
org		#6f3f
		adjust_y_to_bg	; ダチョウスクロール
filler	#6f49

romadr	#2f88
org		#6f88
		adjust_y_to_bg	; ダチョウスクロール
filler	#6f92

romadr	#30b1
org		#70b1
		adjust_y_to_bg	; Z80スクロール
filler	#70bb


; ステージ13セットアップ
romadr	#3245
org		#7245
		include	"slss-03245_setup_st13.asm"
		include	"slss-fill_col_allpages.asm"
		include	"slss-write_a_pcg.asm"
filler	#737a
; ステージ14セットアップ
romadr	#337a
org		#737a
		include	"slss-0337a_setup_st14.asm"
filler	#7447

romadr	#345e
org		#745e
		db	#21	; ステージ15セットアップPCG書き換えが重いのでd200の処理でやる

romadr	#379e
org		#779e
		include	"slss-0379e_fadeout.asm"
filler	#7807


;===============================================================
;	BANK 2
;===============================================================
; 1Pシールド表示
romadr	#42cb
org		#82cb
		ld		ix,update_gauge_shield_1p
		jp		call_bank_pcg_font
filler	#82f4
; 2Pシールド表示
		ld		ix,update_gauge_shield_2p
		jp		call_bank_pcg_font
filler	#8320
; ドッキングエネルギー表示
romadr	#4332
org		#8332
		ld		ix,update_gauge_docking
		jp		call_bank_pcg_font
filler	#836A

; スコア表示更新
romadr	#43c8
org		#83c8
		include	"slss-043c8_score.asm"
filler	#8486


; BULLPUPスクロール1P
romadr	#4702
org		#8702
		adjust_y_to_bg2	#e2f4
filler	#8710
; BULLPUPスクロール2P
romadr	#47ac
org		#87ac
		adjust_y_to_bg2	#e2fc
filler	#87BA
; BULDOGスクロール
romadr	#5196
org		#9196
		adjust_y_to_bg2	#e311
filler	#91a4
; DOUBLEスクロール
romadr	#535f
org		#935f
		adjust_y_to_bg2	#e311
filler	#936d
romadr	#53c1
org		#93c1
		adjust_y_to_bg2	#e315
filler	#93cf



;===============================================================
;	BANK 3
;===============================================================
romadr	#607c
		jp	z,#beff
romadr	#7eff
org		#beff
		include	"slss-07eff_default_pilot.asm"



;===============================================================
;	BANK 4,5,6,7
;===============================================================
bank_pcg_font	equ	4
romadr	#8000
org		#8000
		include	"slss-hkeyi.asm"

		include	"slss-pcg_status.asm"
	pcg_status:
		incbin	"dat/slss-pcg_status.lzsa1r"

	org_add	#2000
	align	0x100
	pcg_font:
		incbin	"dat/slss-pcg_font.dat"
		include	"slss-pcg_font.asm"
	org_sub	#2000

	pcg_bg0:
		include	"slss-pcg_bg.asm"
		incbin	"dat/slss-pcg_00.lzsa1r"
	pcg_bg1:
		include	"slss-pcg_bg.asm"
		incbin	"dat/slss-pcg_01.lzsa1r"
	pcg_bg2:
		include	"slss-pcg_bg.asm"
		incbin	"dat/slss-pcg_02.lzsa1r"
	pcg_bg3:
		include	"slss-pcg_bg.asm"
		incbin	"dat/slss-pcg_03.lzsa1r"
	pcg_bg4:
		include	"slss-pcg_bg.asm"
		incbin	"dat/slss-pcg_04.lzsa1r"
	pcg_bg5:
		include	"slss-pcg_bg.asm"
		incbin	"dat/slss-pcg_05.lzsa1r"
	pcg_bg6:
		include	"slss-pcg_bg.asm"
		incbin	"dat/slss-pcg_06.lzsa1r"
	pcg_bg7:
		include	"slss-pcg_bg.asm"
		incbin	"dat/slss-pcg_07.lzsa1r"
	pcg_bg8:
		include	"slss-pcg_bg.asm"
		incbin	"dat/slss-pcg_08.lzsa1r"
	pcg_bg9:
		include	"slss-pcg_bg.asm"
		incbin	"dat/slss-pcg_09.lzsa1r"
filler	#f800


; ステージ別敵処理
romadr	#ff60+#018f
org		#c18f
		adjust_y_to_bg		; ステージ2テイクオフしてくるやつのスクロール
filler	#c199

;romadr	0x12f0f
;org		#c36f
;		adjust_y_to_bg		; ステージ9何かのスクロール
;filler	#c379


; ステージ別背景処理
romadr	0x14970
org		#d200
		include	"slss-14970_d200_st01.asm"
filler	#d680
romadr	0x14df0
org		#d200
		include	"slss-14df0_d200_st02.asm"
filler	#d590
romadr	0x15180
org		#d200
		include	"slss-15180_d200_st04.asm"
filler	#d5c0
romadr	0x15540
org		#d200
		include	"slss-15540_d200_st05.asm"
filler	#d5aa
romadr	0x159f0
org		#d200
		include	"slss-159f0_d200_st07.asm"
filler	#d385
romadr	0x15b80
org		#d200
		include	"slss-15b80_d200_st08.asm"
filler	#d3f0
romadr	0x15d70
org		#d200
		include	"slss-15d70_d200_st09.asm"
filler	#d321
romadr	0x15ea0
org		#d200
		include	"slss-15ea0_d200_st10.asm"
filler	#d44f
romadr	0x160f0
org		#d200
		include	"slss-160f0_d200_st11.asm"
filler	#d510
romadr	0x16400
org		#d200
		include	"slss-16400_d200_st12.asm"
filler	#d50f


; ステージ別地上物処理
romadr	0x170b0+#0f
org		#d900+#0f
		include	"slss-170bf_d90f_st08.asm"
filler	#d97e


;===============================================================
;
;	値の変更
;
;===============================================================
;===============================================================
;	オプションウェポン表示先の座標指定変更
;===============================================================
irp	ofs,0,1,2,3,4,5,6,7,8,9,10,11
		romadr	0x3C54 + ofs * 9
			dw	#6848
endm


;===============================================================
;	スプライトのy座標のデフォルト値を修正
;===============================================================
; LC_ALL=C grep -abo [$'\x36\x3e\xfe']$'\xd1' ../SuperLaydock.rom | awk -F : '{printf("0x%x, ",$1)}'
macro	sprite_y_default, adr
		romadr	adr + 1
			db	#d1+8
endm

irp	adr, 0x1ab, 0xe93, 0x199d, 0x1a0e, 0x1a57, 0x1e84, 0x1ef5, 0x2618
	sprite_y_default	adr
endm
irp	adr, 0x2762, 0x2afe, 0x2c3e, 0x2ea1, 0x2f9a, 0x2fae, 0x2fc2, 0x2fda
	sprite_y_default	adr
endm
irp	adr, 0x391c, 0x3939, 0x3f45, 0x3f60, 0x3f8c, 0x4044, 0x405f, 0x408b
	sprite_y_default	adr
endm
irp	adr, 0x45f7, 0x46e7, 0x474b, 0x4757, 0x4791, 0x47f5, 0x4801, 0x4d3e
	sprite_y_default	adr
endm
irp	adr, 0x4d48, 0x51e2, 0x51ee, 0x51fb, 0x5306, 0x530c, 0x534c, 0x53ae
	sprite_y_default	adr
endm
irp	adr, 0x540d, 0x5419, 0x54d9, 0x571c, 0x5acf, 0x5af3, 0x5deb, 0x5df1
	sprite_y_default	adr
endm
irp	adr, 0x5e17, 0x5e25, 0x5e30, 0x111af, 0x111c2, 0x111d5, 0x12c7b, 0x12c8e
	sprite_y_default	adr
endm
irp	adr, 0x12ca1, 0x13e55, 0x13e68, 0x13e7b
	sprite_y_default	adr
endm

ifndef SuperLaydock_bv
	irp	adr, 0x4f28, 0x4f3a, 0x5039
		sprite_y_default	adr
	endm
else
	irp	adr, 0x4faa, 0x5042
		sprite_y_default	adr
	endm
endif
